## gromacs 4.5.5

=== include/CMakeLists.txt ===
# includes: Nothing to build, just installation
install(DIRECTORY . DESTINATION ${INCL_INSTALL_DIR}/gromacs
  COMPONENT development
  PATTERN "Makefile*" EXCLUDE
  PATTERN "CMake*" EXCLUDE
  PATTERN "cmake*" EXCLUDE
  PATTERN "*~" EXCLUDE
)

=== man/CMakeLists.txt ===
# Man pages: Nothing to build, just installation
install(DIRECTORY . DESTINATION ${MAN_INSTALL_DIR}
  COMPONENT data
  PATTERN "Makefile*" EXCLUDE
  PATTERN "CMake*" EXCLUDE
  PATTERN "cmake*" EXCLUDE
  PATTERN "*~" EXCLUDE
)

=== scripts/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/GMXRC.cmakein      ${CMAKE_CURRENT_BINARY_DIR}/GMXRC @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/GMXRC.bash.cmakein ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.bash @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/GMXRC.csh.cmakein  ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.csh @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/GMXRC.zsh.cmakein  ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.zsh @ONLY)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/GMXRC      DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.bash DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.zsh  DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/GMXRC.csh  DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)

file(GLOB EXTRA_SCRIPTS completion.*)
install(FILES ${EXTRA_SCRIPTS} DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/demux.pl      DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)
install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/xplor2gmx.pl  DESTINATION ${BIN_INSTALL_DIR} COMPONENT runtime)

=== share/CMakeLists.txt ===
# Data: Nothing to build, just installation
install(DIRECTORY . DESTINATION ${DATA_INSTALL_DIR}
  COMPONENT data
  PATTERN "Makefile*" EXCLUDE
  PATTERN "CMake*" EXCLUDE
  PATTERN "cmake*" EXCLUDE
  PATTERN "template_doc.c" EXCLUDE
  PATTERN "Template.mak" EXCLUDE
  PATTERN "*~" EXCLUDE
)

install(FILES template/CMakeLists.txt.template
        DESTINATION ${DATA_INSTALL_DIR}
        RENAME template/CMakeLists.txt
        COMPONENT data)

=== src/ngmx/CMakeLists.txt ===
if(X11_FOUND)

set(NGMX_COMMON_SOURCE
    xutil.c         xmb.c           x11.c
    xdlghi.c        fgrid.c         xdlgitem.c
    popup.c         pulldown.c      xdlg.c
    manager.c       buttons.c       nmol.c
    nleg.c          dialogs.c       logo.c
    filter.c        molps.c)

include_directories(${X11_INCLUDE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# List of programs with single corresponding *.c source file,
# used to create build rules automatically.
#
set(NGMX_PROGRAMS 
    ngmx g_xrama)

foreach(PROG ${NGMX_PROGRAMS})
        add_executable(${PROG} ${PROG}.c ${NGMX_COMMON_SOURCE})
        target_link_libraries(${PROG} gmx ${GMX_EXTRA_LIBRARIES} ${X11_LIBRARIES})        
        set_target_properties(${PROG} PROPERTIES OUTPUT_NAME "${PROG}${GMX_BINARY_SUFFIX}")
endforeach(PROG) 

install(TARGETS ${NGMX_PROGRAMS}
        COMPONENT ngmx
        RUNTIME DESTINATION ${BIN_INSTALL_DIR})

endif(X11_FOUND)

=== src/tools/CMakeLists.txt ===

add_library(gmxana 
            autocorr.c      expfit.c        polynomials.c   levenmar.c      
            anadih.c        pp2shift.c      dlist.c         
            eigio.c         cmat.c          
            eigensolver.c   nsc.c           
            hxprops.c       fitahx.c        
            geminate.c
            gmx_analyze.c   gmx_anaeig.c    gmx_angle.c     gmx_bond.c      
            gmx_bundle.c    gmx_chi.c       gmx_cluster.c   gmx_confrms.c   
            gmx_covar.c     gmx_current.c   
            gmx_density.c   gmx_densmap.c   gmx_dih.c       
            gmx_dielectric.c        
            gmx_kinetics.c  gmx_spatial.c   gmx_tune_pme.c
            gmx_dipoles.c   gmx_disre.c     gmx_dist.c      gmx_dyndom.c    
            gmx_enemat.c    gmx_energy.c    gmx_lie.c       gmx_filter.c    
            gmx_gyrate.c    gmx_h2order.c   gmx_hbond.c     gmx_helix.c     
            gmx_mindist.c   gmx_msd.c       gmx_morph.c     gmx_nmeig.c     
            gmx_nmens.c     gmx_order.c     gmx_principal.c 
            gmx_polystat.c  gmx_potential.c gmx_rama.c      
            gmx_rdf.c       gmx_rms.c       gmx_rmsf.c      
            gmx_rotacf.c    gmx_saltbr.c    gmx_sas.c              
            gmx_select.c    gmx_rmsdist.c   gmx_rotmat.c
            gmx_sgangle.c   gmx_sorient.c   gmx_spol.c      gmx_tcaf.c      
            gmx_traj.c      gmx_velacc.c    gmx_helixorient.c 
            gmx_clustsize.c gmx_mdmat.c     gmx_wham.c      
            correl.c        gmx_sham.c      gmx_nmtraj.c    
            gmx_trjconv.c   gmx_trjcat.c    gmx_trjorder.c  gmx_xpm2ps.c    
            gmx_editconf.c  gmx_genbox.c    gmx_genion.c    gmx_genconf.c   
            gmx_genpr.c     gmx_eneconv.c   gmx_vanhove.c   gmx_wheel.c     
            addconf.c       calcpot.c       edittop.c       gmx_bar.c
            gmx_membed.c    gmx_pme_error.c gmx_options.c   gmx_dos.c
            gmx_hydorder.c  gmx_densorder.c powerspect.c    dens_filter.c
            binsearch.c
            )


target_link_libraries(gmxana md gmx ${GSL_LIBRARIES})
set_target_properties(gmxana PROPERTIES OUTPUT_NAME "gmxana${GMX_LIBS_SUFFIX}" SOVERSION ${SOVERSION} INSTALL_NAME_DIR "${LIB_INSTALL_DIR}")

# List of programs with single corresponding .c source file,
# used to create build rules automatically.
#
set(GMX_TOOLS_PROGRAMS
    do_dssp editconf eneconv genbox genconf genrestr g_nmtraj 
    make_ndx mk_angndx trjcat trjconv trjorder g_wheel 
    xpm2ps genion g_anadock make_edi g_analyze g_anaeig
    g_angle g_bond g_bundle g_chi g_cluster g_confrms g_covar
    g_current g_density g_densmap g_dih g_dielectric
    g_helixorient g_principal g_dipoles g_disre g_dist
    g_dyndom g_enemat g_energy g_lie g_filter g_gyrate
    g_h2order g_hbond g_helix g_mindist g_msd g_morph g_nmeig
    g_nmens g_order g_kinetics g_polystat g_potential g_rama g_rdf g_rms
    g_rmsf g_rotacf g_saltbr g_sas g_select g_sgangle g_sham g_sorient
    g_spol g_spatial g_tcaf g_traj g_tune_pme g_vanhove
    g_velacc g_clustsize g_mdmat g_wham g_sigeps g_bar
    g_membed g_pme_error g_rmsdist g_rotmat g_options
    g_dos    g_hydorder  g_densorder
    )

set(GMX_TOOLS_PROGRAMS_NOT_FOR_INSTALLATION
  # names of any executables that should be built but not installed can go here
    )


foreach(TOOL ${GMX_TOOLS_PROGRAMS} ${GMX_TOOLS_PROGRAMS_NOT_FOR_INSTALLATION})
    add_executable(${TOOL} ${TOOL}.c)
    target_link_libraries(${TOOL} gmxana)
    set_target_properties(${TOOL} PROPERTIES OUTPUT_NAME "${TOOL}${GMX_BINARY_SUFFIX}")
endforeach(TOOL ${GMX_TOOLS_PROGRAMS}) 


install(TARGETS gmxana DESTINATION ${LIB_INSTALL_DIR} COMPONENT runtime)
install(TARGETS ${GMX_TOOLS_PROGRAMS}
        DESTINATION ${BIN_INSTALL_DIR}
        COMPONENT runtime)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libgmxana.pc.cmakein ${CMAKE_CURRENT_BINARY_DIR}/libgmxana.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgmxana.pc
        DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
        RENAME "libgmxana${GMX_LIBS_SUFFIX}.pc"
        COMPONENT development)

=== debian/changelog ===
gromacs (4.5.5-2) unstable; urgency=low

  [ Andreas Tille ]
  * debian/upstream:
     - copied citations from tasks/bio to debian/upstream
     - make last citation conform to BibTeX syntax

  [ Nicholas Breen ]
  * Update to current release-4.5-patches git (f361fa9c) via addition of
    patches/10_release-4.5-patches.patch.
  * source/format: Move to 3.0 (quilt).  Adjust patches accordingly.
  * control: Remove specific listing of MPI packages from description of
    gromacs-dev.  (Closes: #644820)  Update maintainer address and drop
    DMUA stanza.  Drop Build-Depends on dpatch, add on hardening-wrapper.
    Update to S-V 3.9.3, no packaging changes required.
  * rules, README.source: Remove dpatch cruft.
  * rules: Apply compiler hardening flags with hardening-wrapper.
  * patches/*: Tidy up with DEP-3 headers.
  * control, rules: Update list of architectures for gromacs-openmpi,
    adding armel, armhf, powerpcspe, and sparc64.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 09 Jun 2012 11:42:56 -0700

gromacs (4.5.5-1) unstable; urgency=low

  * New upstream release.
    - Remove patches/30_git_release-4.5-patches.dpatch.
    - man/g_dos.1: Create man page for new binary.
  * rules: Add build-arch/build-indep targets.  Add preliminary support for
    building GPU-accelerated binaries: set DEB_BUILD_OPTIONS=gpu to try it.
  * patches/31_manpages.dpatch: Update.

 -- Nicholas Breen <nbreen@ofb.net>  Wed, 21 Sep 2011 19:10:08 -0700

gromacs (4.5.4-2) unstable; urgency=low

  * control: remove obsolete Build-Depends and Suggests on libice-dev,
    libsm-dev, libxext-dev, libxp-dev, libxt-dev.  Update Standards-Version
    to 3.9.2.
  * patches/30_git_release-4.5-patches.dpatch: Routine update from upstream
    git, to commit 873563ef of 22 April 2011.
  * patches/31_manpages.dpatch: Various minor spelling and header fixes.
  * lintian-overrides.gromacs: Remove checks no longer needed, per #120323.
  * rules: Switch to using dh_lintian.

 -- Nicholas Breen <nbreen@ofb.net>  Mon, 25 Apr 2011 13:47:00 -0700

gromacs (4.5.4-1) unstable; urgency=low

  * New upstream release.
  * Remove gromacs-lam transitional package.
  * man/g_options.1: Create man page for new binary.
  * lintian-overrides.gromacs-data: Override script-not-executable for demo
    scripts not in $PATH.

 -- Nicholas Breen <nbreen@ofb.net>  Mon, 21 Mar 2011 19:59:54 -0700

gromacs (4.5.3-1) unstable; urgency=low

  * New upstream release.
  * Force -DGMX_X11=ON to build ngmx.  (Closes: #603327)

 -- Nicholas Breen <nbreen@ofb.net>  Sat, 13 Nov 2010 12:02:17 -0800

gromacs (4.5.2-1) unstable; urgency=low

  * Major new upstream release.
  * All patches incorporated upstream and removed, except the Debian-
    specific bug reporting portion of 11_readme.dpatch.
  * man/gromacs.7: incorporated upstream, removed from Debian patch.
  * man/luck.1: Rename to g_luck.1 and edit to reflect new name.
  * man/mdrun_mpi.*.1: Resynchronize with upstream mdrun.1.
  * watch: Update to recognize -betaX tarballs and ignore -GPU builds.
  * rules: Convert from autotools to new CMake build system.
  * control:
    - Add Build-Depends on libxml2-dev.
    - Update Standards-Version to 3.9.1.
    - Replace Conflicts: with Breaks:.

 -- Nicholas Breen <nbreen@ofb.net>  Wed, 03 Nov 2010 17:39:52 -0700

gromacs (4.0.7-3) unstable; urgency=low

  * New patch 03_autoconf_bashisms.dpatch: Eliminate two bashisms (test ==
    instead of =) in configure.ac, permitting use with dash instead.
  * patches/30_git_release-4.0-patches.dpatch: Update to commit
    36df279783944c11d1ba43936ea820f8e6003ffd.

 -- Nicholas Breen <nbreen@ofb.net>  Tue, 25 May 2010 19:30:48 -0700

gromacs (4.0.7-2) unstable; urgency=low

  * rules: 
    - Drop chrpath workaround, underlying bug solved with mpich2 
      1.2.1.1-2.
    - Add sparc to list of architectures for -openmpi.
  * control:
    - Per above.
    - Set DM-Upload-Allowed: yes.
    - Update Standards-Version to 3.8.4.
    - Add ${misc:Depends} for Lintian, except for -data and -lam which
      receive overrides instead.
  * gromacs-parallel.README.Debian.in: Remove reference to LAM-MPI.
  * patches/30_git_release-4.0-patches.dpatch: Update to commit
    444432a51f87f003fc6e7098f9e07a2a2d142c64.
  * source/format: Create and set explicitly to 1.0.
  * source/lintian-overrides: Override debhelper-but-no-misc-depends for
    gromacs-data and gromacs-lam.

 -- Nicholas Breen <nbreen@ofb.net>  Tue, 13 Apr 2010 23:33:27 -0700

gromacs (4.0.7-1) unstable; urgency=low

  * New upstream release.
  * patches/30_git_release-4.0-patches.dpatch: Empty out, replace with
    fresh pull starting at the 4.0.7 release; current to git commit
    665dce86638df8ac1062b0b022d7827ea0f11788.

 -- Nicholas Breen <nbreen@ofb.net>  Thu, 31 Dec 2009 16:43:03 -0800

gromacs (4.0.5-5) unstable; urgency=low

  * Transition to only the two supported MPI implementations:
    - gromacs-mpich now builds against MPICH2, not MPICH1.
    - gromacs-lam replaced with a dummy package installing gromacs-
      openmpi on all supported architectures, -mpich on the holdouts.
    - Update documentation accordingly.
  * patches/30_git_release-4.0-patches.dpatch: Pull from upstream git
    repository, release-4.0-patches branch.  Current to git commit
    37a4dd35fec7579ca7faca25c62c71cf1d8e1621, 29 Nov. 2009.
  * patches/21_makefile_dups.dpatch: Delete, incorporated above
    (commit c93db8511af09c144fe4b2b8f57b14a5ad1e6cc7).
  * compat: Update to debhelper v7 mode.
    - rules: Replace dh_clean -k with dh_prep.
    - control: Adjust Build-Depends to debhelper (>= 7.0.0).
  * copyright: Increment year.
  * rules: Use chrpath to eliminate RPATH from MPICH2-compiled binaries.
    This is a workaround for a libmpich2-dev bug, #558960.
    - control: Add chrpath to Build-Depends.
  * rules: Add -Wl,--as-needed to LDFLAGS.

 -- Nicholas Breen <nbreen@ofb.net>  Mon, 30 Nov 2009 16:18:34 -0800

gromacs (4.0.5-4) unstable; urgency=low



=== debian/control ===
Source: gromacs
Section: science
Priority: extra
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Nicholas Breen <nbreen@debian.org>
Build-Depends: debhelper (>= 7.0.0), libfftw3-dev, libmpich2-dev, libopenmpi-dev (>= 1.2.4-5) [alpha amd64 armel armhf i386 ia64 powerpc powerpcspe sparc sparc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386], lesstif2-dev, libx11-dev, zlib1g-dev, libgsl0-dev, gfortran [alpha], libxml2-dev, cmake, hardening-wrapper
Standards-Version: 3.9.3
Homepage: http://www.gromacs.org/
Vcs-Browser: http://svn.debian.org/wsvn/debichem/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/gromacs/

Package: gromacs
Architecture: any
Depends: gromacs-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: cpp
Breaks: radiance (<= 3R8+20070924.dfsg-1)
Description: Molecular dynamics simulator, with building and analysis tools
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 GROMACS offers entirely too many features for a brief description to do it
 justice.  A more complete listing is available at
 <http://www.gromacs.org/content/view/12/176/>.

Package: gromacs-data
Architecture: all
Recommends: gromacs
Suggests: tcsh | c-shell
Conflicts: gromacs-doc
Breaks: gromacs (<< 3.3.3-1)
Replaces: gromacs-doc
Description: GROMACS molecular dynamics sim, data and documentation
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains architecture-independent topology and force field
 data, documentation, man pages, and example files.

Package: gromacs-dev
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, gromacs (= ${binary:Version}), fftw3-dev, ${misc:Depends}
Recommends: gromacs-data
Suggests: gromacs-mpich (= ${binary:Version}) | gromacs-openmpi (= ${binary:Version}) [alpha amd64 armel armhf i386 ia64 powerpc powerpcspe sparc sparc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386], libmpich2-dev, lesstif2-dev, libx11-dev, zlib1g-dev
Description: GROMACS molecular dynamics sim, development kit
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains header files and static libraries for development
 purposes, plus sample Makefiles.  Development components for MPI-enabled
 GROMACS builds also require their respective packages.

Package: gromacs-mpich
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mpich2
Recommends: gromacs
Suggests: gromacs-data
Description: Molecular dynamics sim, binaries for MPICH parallelization
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains only the core simulation engine with parallel
 support using the MPICH (v2) interface.  It is suitable for nodes of a
 processing cluster, or for multiprocessor machines.

Package: gromacs-openmpi
Architecture: alpha amd64 armel armhf i386 ia64 powerpc powerpcspe sparc sparc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-bin (>= 1.2.3)
Recommends: gromacs
Replaces: gromacs-lam
Suggests: gromacs-data
Description: Molecular dynamics sim, binaries for OpenMPI parallelization
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains only the core simulation engine with parallel
 support using the OpenMPI interface.  It is suitable for nodes of a
 processing cluster, or for multiprocessor machines.

=== debian/rules ===
#!/usr/bin/make -f
#
# build script for GROMACS

# export DH_VERBOSE=1

PACKAGE := gromacs

# OpenMPI is only supported on a subset of architectures at this time.
# This list should remain synced with the Build-Depends and the Architecture
# line of gromacs-openmpi in debian/control.

OPENMPI_ARCH    = alpha amd64 armel armhf i386 ia64 powerpc powerpcspe sparc sparc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# add hardening flags, using hardening-wrapper
export DEB_BUILD_HARDENING=1

CFLAGS =
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -Wall
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
endif

LDFLAGS += -Wl,--as-needed

COMMON_CONFIG_PARAMS = \
	$(CURDIR) \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DGMX_X11=ON

ifneq ($(CFLAGS),)
	COMMON_CONFIG_PARAMS += -DCMAKE_C_FLAGS="$(CFLAGS)"
endif

# Include "gpu" in DEB_BUILD_OPTIONS to build GPU-accelerated binaries as well.
# See INSTALL-GPU.  This build option is not tested, please send comments.
# You must have OpenMM development headers (not packaged) and "nvidia-cuda-dev"
# installed!
ifneq (,$(findstring gpu,$(DEB_BUILD_OPTIONS)))
	COMMON_CONFIG_PARAMS += -DGMX_OPENMM=ON -DGMX_THREADS=OFF
endif

MPICH_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DGMX_THREADS=OFF \
	-DGMX_X11=OFF \
	-DGMX_DEFAULT_SUFFIX=FALSE

OPENMPI_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DGMX_THREADS=OFF \
	-DGMX_DEFAULT_SUFFIX=FALSE \
	-DGMX_FORTRAN=OFF \
	-DGMX_X11=OFF \
	-DCMAKE_EXE_LINKER_FLAGS="-L/usr/lib/openmpi/lib $(LDFLAGS)"

# optional parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE += -j$(NUMJOBS)
endif

# gfortran transition: configure script looks for f77/g77 binaries, not f95/g95/gfortran
# FORTRAN inner loops are used on Alpha only
ifneq (,$(findstring alpha,$(DEB_HOST_ARCH)))
	export F77=/usr/bin/gfortran
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	(mkdir -p build/basic; cd build/basic; cmake $(COMMON_CONFIG_PARAMS) -DGMX_MPI=OFF)
	(mkdir -p build/basic-dp; cd build/basic-dp; cmake $(COMMON_CONFIG_PARAMS) -DGMX_MPI=OFF -DGMX_DOUBLE=ON)
	(mkdir -p build/mpich; cd build/mpich; CC=/usr/bin/mpicc.mpich2 cmake \
	$(COMMON_CONFIG_PARAMS) $(MPICH_CONFIG_PARAMS) -DGMX_BINARY_SUFFIX="_mpi.mpich" -DGMX_LIBS_SUFFIX="_mpi.mpich")
	(mkdir -p build/mpich-dp; cd build/mpich-dp; CC=/usr/bin/mpicc.mpich2 cmake \
	$(COMMON_CONFIG_PARAMS) $(MPICH_CONFIG_PARAMS) -DGMX_DOUBLE=ON -DGMX_BINARY_SUFFIX="_mpi_d.mpich" -DGMX_LIBS_SUFFIX="_mpi_d.mpich")
ifneq (,$(findstring $(DEB_HOST_ARCH),$(OPENMPI_ARCH)))
	(mkdir -p build/openmpi; cd build/openmpi; CC=/usr/bin/mpicc.openmpi cmake \
	$(COMMON_CONFIG_PARAMS) $(OPENMPI_CONFIG_PARAMS) -DGMX_BINARY_SUFFIX="_mpi.openmpi" -DGMX_LIBS_SUFFIX="_mpi.openmpi")
	(mkdir -p build/openmpi-dp; cd build/openmpi-dp; CC=/usr/bin/mpicc.openmpi cmake \
	$(COMMON_CONFIG_PARAMS) $(OPENMPI_CONFIG_PARAMS) -DGMX_DOUBLE=ON -DGMX_BINARY_SUFFIX="_mpi_d.openmpi" -DGMX_LIBS_SUFFIX="_mpi_d.openmpi")
endif
	touch $@


build: configure-stamp build-basic build-mpich build-openmpi

build-arch: build
build-indep: build

build-basic: configure-stamp
	dh_testdir
	$(MAKE) -C build/basic
	$(MAKE) -C build/basic-dp
	touch $@

build-mpich: configure-stamp
	dh_testdir
	$(MAKE) -C build/mpich mdrun 
	$(MAKE) -C build/mpich-dp mdrun
	sed -e 's/#MPIABBR#/mpich/g' -e 's/#MPIPROG#/MPICH2/g' \
	    < debian/gromacs-parallel.README.Debian.in \
	    > debian/gromacs-mpich.README.Debian
	touch $@
	
build-openmpi: configure-stamp
	dh_testdir
ifneq (,$(findstring $(DEB_HOST_ARCH),$(OPENMPI_ARCH)))
	$(MAKE) -C build/openmpi mdrun
	$(MAKE) -C build/openmpi-dp mdrun
	sed -e 's/#MPIABBR#/openmpi/g' -e 's/#MPIPROG#/OpenMPI/g' \
	    < debian/gromacs-parallel.README.Debian.in \
	    > debian/gromacs-openmpi.README.Debian
endif
	touch $@	


clean: 
	dh_testdir
	dh_testroot
	rm -rf build
	dh_clean build-basic build-mpich build-openmpi configure-stamp \
	         debian/gromacs-mpich.README.Debian debian/gromacs-openmpi.README.Debian


install: build install-basic install-mpich install-openmpi
	dh_testdir
	dh_testroot
	dh_prep -pgromacs-data -pgromacs-dev
	
	# remove a duplicated file
	rm -f $(CURDIR)/debian/gromacs/usr/share/gromacs/tutor/gmxdemo/demo_d
	
	dh_installdirs -pgromacs-data
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/top \
	   $(CURDIR)/debian/gromacs-data/usr/share/gromacs
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/tutor \
	   $(CURDIR)/debian/gromacs-data/usr/share/gromacs
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/html \
	   $(CURDIR)/debian/gromacs-data/usr/share/doc/gromacs
	mv $(CURDIR)/debian/gromacs/usr/share/man \
	   $(CURDIR)/debian/gromacs-data/usr/share/man
	# some of the default installation directories for documentation and
	# example shell scripts are not FHS-friendly; move them appropriately
	mv $(CURDIR)/debian/gromacs/usr/bin/GMXRC* \
	   $(CURDIR)/debian/gromacs/usr/bin/completion* \
	   $(CURDIR)/debian/gromacs-data/usr/share/gromacs/shell-specific
	chmod 644 $(CURDIR)/debian/gromacs-data/usr/share/gromacs/shell-specific/*
	dh_link -pgromacs-data usr/share/doc/gromacs/html usr/share/doc/gromacs-data/html
	dh_link -pgromacs-data usr/share/doc/gromacs/html usr/share/doc/gromacs-dev/html
	# one lintian warning is overridden:
	# - script-not-executable: demo scripts outside of $PATH
	dh_lintian -pgromacs-data
	# rename a pair of Perl scripts to drop the .pl extension (Policy 10.4)
	mv $(CURDIR)/debian/gromacs/usr/bin/demux.pl     $(CURDIR)/debian/gromacs/usr/bin/demux
	mv $(CURDIR)/debian/gromacs/usr/bin/xplor2gmx.pl $(CURDIR)/debian/gromacs/usr/bin/xplor2gmx

	dh_installdirs -pgromacs-dev
	mv $(CURDIR)/debian/gromacs/usr/include $(CURDIR)/debian/gromacs-dev/usr/include
	# catch normal libraries plus all applicable MPI variants
	mv $(CURDIR)/debian/gromacs/usr/lib/*.so $(CURDIR)/debian/gromacs/usr/lib/pkgconfig $(CURDIR)/debian/gromacs-dev/usr/lib
	mv $(CURDIR)/debian/gromacs-mpich/usr/lib/*.so $(CURDIR)/debian/gromacs-dev/usr/lib
ifneq (,$(findstring $(DEB_HOST_ARCH),$(OPENMPI_ARCH)))
	mv $(CURDIR)/debian/gromacs-openmpi/usr/lib/*.so $(CURDIR)/debian/gromacs-dev/usr/lib
endif
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/template $(CURDIR)/debian/gromacs-dev/usr/share/gromacs/template
	-rmdir $(CURDIR)/debian/gromacs/usr/share/gromacs


install-basic: build
	dh_testdir
	dh_testroot
	dh_prep -pgromacs
	dh_installdirs -pgromacs
	$(MAKE) -C build/basic install DESTDIR=$(CURDIR)/debian/gromacs
	$(MAKE) -C build/basic-dp install DESTDIR=$(CURDIR)/debian/gromacs
	rm -f $(CURDIR)/debian/gromacs/usr/share/man/man1/*_d.1
	dh_installman -pgromacs debian/man/g_*.1
	for manpage in $(CURDIR)/debian/gromacs/usr/share/man/man1/*.1; do \
		dh_link -pgromacs usr/share/man/man1/`basename $${manpage}` usr/share/man/man1/`basename $${manpage} .1`_d.1 ; \
	done
	# man pages for a pair of Perl scripts are installed *after* the _d duplication,
	# as they have no double-precision variants.
	dh_installman -pgromacs debian/man/demux.1 debian/man/xplor2gmx.1
	# this program is currently broken - keep it from shipping until fixed
	rm $(CURDIR)/debian/gromacs/usr/bin/g_pme_error $(CURDIR)/debian/gromacs/usr/bin/g_pme_error_d
	# two lintian warnings are overridden:
	# - package-name-doesnt-match-sonames: the libraries are private to
	#   GROMACS, and it's unlikely that any new package will start using
	#   them; therefore, separate lib packages would just be bloat.
	#   This is also overridden for the -mpich and -openmpi packages.
	# - shlib-with-executable-stack: it's a side effect of the ASM inner
	#   loops (i386/amd64 only)
	dh_lintian -pgromacs

install-mpich: build
	dh_testdir
	dh_testroot
	dh_prep -pgromacs-mpich
	dh_installdirs -pgromacs-mpich
	$(MAKE) -C build/mpich install-mdrun DESTDIR=$(CURDIR)/debian/gromacs-mpich

=== debian/watch ===
# See uscan(1) for format

version=3
opts=uversionmangle=s/[-_]((pre|beta)[^.]+)/~$1/ \
  ftp://ftp.gromacs.org/pub/gromacs/gromacs-([\d\.betapr_-]*)\.tar\.gz
